#version 430 core

layout (triangles_adjacency) in;
layout (triangle_strip, max_vertices = 18) out;

in vec3 pos[];

uniform vec3 lightPos;
uniform mat4 viewProjMatrix;
//uniform mat4 modelMatrix;

float e = 0.05;
 mat4 mvp;

void emitQuad(vec3 vert1, vec3 vert2){ 
   
   vec3 directionL = normalize(vert1 - lightPos);
    gl_Position = mvp * vec4((vert1 + directionL * e), 1);
    EmitVertex();

    gl_Position = mvp * vec4(directionL, 0);
    EmitVertex();

    directionL = normalize(vert2 - lightPos);
    gl_Position = mvp * vec4((vert2 + directionL * e), 1);
    EmitVertex();

    gl_Position = mvp * vec4(directionL, 0);
    EmitVertex();

    EndPrimitive();
}

void main(){
    mvp =  viewProjMatrix;// * modelMatrix;

    vec3 e1 = pos[2] - pos[0];
    vec3 e2 = pos[4] - pos[0];
    vec3 e3 = pos[1] - pos[0];
    vec3 e4 = pos[3] - pos[2];
    vec3 e5 = pos[4] - pos[2];
    vec3 e6 = pos[5] - pos[0];

    vec3 normal = normalize(cross(e1,e2));
    vec3 directionL = normalize(lightPos - pos[0]);

    if(dot(normal, directionL) > 0){
       
       normal = cross(e3, e1);
        if(dot(normal, directionL) <= 0){
            emitQuad(pos[0], pos[2]);
        }
        
        normal = cross(e4, e5);
        directionL = lightPos - pos[2];
        if(dot(normal, directionL) <= 0){
            emitQuad(pos[2], pos[4]);
        }
        
        normal = cross(e2, e6);
        directionL = lightPos - pos[4];
        if(dot(normal, directionL) <= 0){
            emitQuad(pos[4], pos[0]);
        }
        
        directionL = normalize(pos[0] - lightPos);
        gl_Position =  mvp * vec4((pos[0] + directionL * e), 1);
        EmitVertex();

        directionL = normalize(pos[2] - lightPos);
        gl_Position =  mvp * vec4((pos[2] + directionL * e), 1);
        EmitVertex();

        directionL = normalize(pos[4] - lightPos);
        gl_Position =  mvp * vec4((pos[4] + directionL * e), 1);
        EmitVertex();
        EndPrimitive();


        directionL = pos[0] - lightPos;
        gl_Position = mvp * vec4(directionL, 0);
        EmitVertex();

        directionL = pos[4] - lightPos;
        gl_Position = mvp * vec4(directionL, 0);
        EmitVertex();

        directionL = pos[2] - lightPos;
        gl_Position = mvp * vec4(directionL, 0);
        EmitVertex();
        EndPrimitive();
    }
}
